/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaMercadoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.entidad.CategoriaMercado;
import com.rjconsultores.ventaboletos.service.CategoriaMercadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Administrador
 */
@Service("categoriaMercadoService")
public class CategoriaMercadoServiceImpl implements CategoriaMercadoService {

    @Autowired
    private CategoriaMercadoDAO categoriaMercadoDAO;

    public List<CategoriaMercado> obtenerTodos() {
        return categoriaMercadoDAO.obtenerTodos();
    }

    public CategoriaMercado obtenerID(Integer id) {
        return categoriaMercadoDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaMercado suscribir(CategoriaMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaMercadoDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaMercado actualizacion(CategoriaMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaMercadoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        categoriaMercadoDAO.actualizacion(entidad);
    }

    public CategoriaMercado busquedaPoCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaMercadoDAO.busquedaPoCategoriaCtrl(categoriaCtrl);
    }
    
    @Override
	@Transactional
	public void actualizacionAuditagem(List<CategoriaMercado> lsCategoriaMercado) {
		for (CategoriaMercado cc : lsCategoriaMercado) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			categoriaMercadoDAO.actualizacion(cc);
		}		
	}
}
